import java.awt.event.KeyEvent;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileWriter;

// shapes
PShape ship;
PShape life;
PShape shipflame;
PShape zero;
PShape one;
PShape two;
PShape three;
PShape four;
PShape five;
PShape six;
PShape seven;
PShape eight;
PShape nine;
PShape roid1;
PShape roid2;
PShape roid3;
PShape roid4;
PShape[] alienSprites = new PShape[2];
PShape[] redAlienSprites = new PShape[2];
PShape bullet;
PShape explosionpoint;
// screen stuff
int alpha = 112;
final int w = 800;
final int h = 600;
boolean blur = true;
// world stuff
int status = 0;
Entity empty = new EmptyEntity();
Entity[] asteroids = new Entity[4];
Entity[] bullets = new Entity[0];
Entity[] asteroidsHome = new Entity[12];
Entity[] explosions = new Entity[0];
Entity alien = empty;
Entity alienBullet = empty;
Entity selectedOne = empty;
int level = 1;
int score = 0;
int hiScore = 0;
int lives = 3;
int extraLives = 0;
int warptime = 0;
int leveltime = 0;
boolean paused = false;
final float deceleration = pow(0.5, 1.0 / 60);
final float speedunit = 2.0;
PFont font1;
PFont font2;
PFont font3;
// ship stuff
float px = w / 2;
float py = h / 2;
float vx = 0;
float vy = 0;
float angle = -PI / 2;
final float turnangle = ((2 * PI) / 60) * 4 / 5;
boolean left = false;
boolean right = false;
boolean thrust = false;
boolean onScreen = false;
boolean shipDied = false;
int flames = 0;
void setup() {
  size(w, h, P2D);
  background(0);
  // ship and life
  int[][] shipshape = new int[][] {{0, -16},
    {-8, 8},
    {-4, 2},
    {4, 2},
    {8, 8},
    {0, -16}};
  ship = newAsteroidsShape(shipshape);
  life = newAsteroidsShape(shipshape);
  // shipflame
  shipflame = newAsteroidsShape(new int[][] {{0, -16},
    {-8, 8},
    {-4, 2},
    {3, 2},
    {0, 8},
    {-3, 2},
    {4, 2},
    {8, 8},
    {0, -16}});
  // zero
  zero = newAsteroidsShape(new int[][] {{0, 0},
    {0, 20},
    {15, 20},
    {15, 0},
    {0, 0}});
  // one
  one = newAsteroidsShape(new int[][] {{15, 0},
    {15, 20}});
  // two
  two = newAsteroidsShape(new int[][] {{0, 0},
    {15, 0},
    {15, 10},
    {0, 10},
    {0, 20},
    {15, 20}});
  // three
  three = newAsteroidsShape(new int[][] {{0, 0},
    {15, 0},
    {15, 10},
    {0, 10},
    {15, 10},
    {15, 20},
    {0, 20}});
  // four
  four = newAsteroidsShape(new int[][] {{0, 0},
    {0, 10},
    {15, 10},
    {15, 0},
    {15, 20}});
  // five
  five = newAsteroidsShape(new int[][] {{15, 0},
    {0, 0},
    {0, 10},
    {15, 10},
    {15, 20},
    {0, 20}});
  // six
  six = newAsteroidsShape(new int[][] {{0, 0},
    {0, 20},
    {15, 20},
    {15, 10},
    {0, 10}});
  // seven
  seven = newAsteroidsShape(new int[][] {{0, 0},
    {15, 0},
    {15, 20}});
  // eight
  eight = newAsteroidsShape(new int[][] {{0, 10},
    {0, 20},
    {15, 20},
    {15, 0},
    {0, 0},
    {0, 10},
    {15, 10}});
  // nine
  nine = newAsteroidsShape(new int[][] {{15, 10},
    {0, 10},
    {0, 0},
    {15, 0},
    {15, 20}});
  // asteroid1
  roid1 = newAsteroidsShape(new int[][] {{-15, -40},
    {0, -30},
    {20, -40},
    {40, -20},
    {15, -10},
    {40, 10},
    {15, 40},
    {-10, 25},
    {-20, 40},
    {-40, 20},
    {-30, 0},
    {-40, -20},
    {-15, -40}});
  // asteroid2
  roid2 = newAsteroidsShape(new int[][] {{-20, -40},
    {5, -40},
    {40, -20},
    {40, -10},
    {0, 0},
    {40, 20},
    {20, 40},
    {5, 30},
    {-25, 40},
    {-40, 10},
    {-40, -20},
    {-10, -20},
    {-20, -40}});
  // asteroid3
  roid3 = newAsteroidsShape(new int[][] {{-10, -40},
    {20, -40},
    {40, -10},
    {40, 0},
    {10, 40},
    {-10, 40},
    {-5, 5},
    {-25, 40},
    {-40, 10},
    {-20, 0},
    {-40, -10},
    {-10, -40}});
  // asteroid4
  roid4 = newAsteroidsShape(new int[][] {{-20, -40},
    {0, -20},
    {20, -40},
    {40, -25},
    {25, -5},
    {40, 20},
    {10, 40},
    {-25, 40},
    {-40, 25},
    {-40, -20},
    {-20, -40}});
  // alien sprites- 4 versions that don't get cloned
  // special treatment since they're of type GROUP
  alienSprites[0] = newAlienShape(true, false);
  alienSprites[1] = newAlienShape(false, false);
  redAlienSprites[0] = newAlienShape(true, true);
  redAlienSprites[1] = newAlienShape(false, true);

  // bullet
  bullet = createShape(ELLIPSE, -2, -2, 4, 4);
  bullet.fill(255);
  bullet.noStroke();
  // explosion point
  explosionpoint = createShape(ELLIPSE, -1, -1, 2, 2);
  explosionpoint.fill(255);
  explosionpoint.noStroke();
  // asteroids
  for (int i = 0; i < 4; i++) {
    asteroids[i] = newLargeAsteroid();
  }
  // home screen asteroids
  for (int j = 0; j < 4; j++) {
    asteroidsHome[j * 3] = newLargeAsteroid();
    asteroidsHome[j * 3 + 1] = newMedAsteroid();
    asteroidsHome[j * 3 + 2] = newSmallAsteroid(); 
  }
  // fonts
  font1 = loadFont("Bauhaus93-64.vlw");
  font2 = createFont("Monospaced", 24);
  font3 = loadFont("Bandal-64.vlw");
  // load hiscore from a stored file
  try {
    FileInputStream input = new FileInputStream(new File("hiscore.txt"));
    String s = "";
    for (int next = input.read(); next >= 0; next = input.read()) {
      s = s + (char)(next);
    }
    hiScore = Integer.parseInt(s);
  } catch(Exception e) {
  }
}

// the update function
void draw() {
  // if the game is on the start screen, draw it
  if (status == 0)
    drawHomeScreen();
  // if the game is in the playing screen, draw it
  else if(status == 1)
    drawWorld();
  // if the game is over, draw the end screen
  else
    drawEndScreen();
}
// Handling of keys that are pressed during the game
void keyPressed() {
  // Will only allow these keys to be pressed if the game is in play mode
  if(status == 1){
    if(!paused && onScreen) {
      // W key moves the ship forward
      if (keyCode == KeyEvent.VK_W)
        thrust = true;
      // A key rotates the ship counter-clockwise
      else if (keyCode == KeyEvent.VK_A)
        left = true;
      // D key rotates the ship clockwise
      else if (keyCode == KeyEvent.VK_D)
        right = true;
      // S key warps the ship to a randomly chosen location on the screen
      else if (keyCode == KeyEvent.VK_S)
        warpShip();
      // Shift key allows the blur effect to be turned on and off
      else if (keyCode == KeyEvent.VK_SHIFT)
        blur = !blur;
      // Space key shoots a bullet from the nose of the ship
      else if (keyCode == KeyEvent.VK_SPACE)
        shoot();
    }
    // P pauses or unpauses the game
    if (keyCode == KeyEvent.VK_P)
      paused = !paused;
    // Up key increases motion blur effect
    else if (keyCode == KeyEvent.VK_UP) {
      if (alpha >= 8)
        alpha -= 8;
    // Down key decreases motion blur effect
    } 
    else if (keyCode == KeyEvent.VK_DOWN) {
      if (alpha <= 247)
        alpha += 8;
    // Left key resets the blur effect
    } 
    else if (keyCode == KeyEvent.VK_LEFT)
      alpha = 112;
    // R key resets the game to the start screen while playing the game
    else if (keyCode == KeyEvent.VK_R) {
      warptime = 180;
      onScreen = false;
      shipDied = true;
      lives = 1;
      updateShip();
      resetGame();
    }
      
  // If the game is on the starting screen and the enter button is pressed
  // the game starts playing
  } 
  else if (keyCode == KeyEvent.VK_ENTER && status == 0) {
    status = 1;
    onScreen = true;
  }
  // If the games is on the end game screen and the enter button is pressed
  // the game returns to the starting screen and resets all of the 
  // startup variables
  else if (keyCode == KeyEvent.VK_ENTER && status == 2)
    resetGame();
}

// Handles key releases for certain keys
void keyReleased() {
  // W key is released, thrusting is turned off for the ship
  if (keyCode == KeyEvent.VK_W)
    thrust = false;
  // A key is released, rotating of the ship ends
  else if (keyCode == KeyEvent.VK_A)
    left = false;
  // D key is released, rotating of the ship ends
  else if (keyCode == KeyEvent.VK_D)
    right = false;
}

// Handles mouse clicks
void mousePressed() {
  if(status != 1)
    return;
  //don’t select while paused
  if (!paused) {
    for (int i = 0; i < asteroids.length; i += 1) {
      if (asteroids[i].mouseWithin()) {
        selectedOne = asteroids[i];
        return;
      }
    }
    if(alien.mouseWithin()) {
     selectedOne = alien; 
     return;
    }
    //nothing got clicked
    selectedOne = empty;
  }
}

// helper method to simplify creating a new shape for the Asteroidz game
PShape newAsteroidsShape(int[][] points) {
  PShape s = createShape();
  for (int i = 0; i < points.length; i += 1) {
    s.vertex(points[i][0], points[i][1]);
  }
  s.end();
  s.stroke(255);
  s.noFill();
  return s;
}

// creates a new alien shape
PShape newAlienShape(boolean small, boolean red) {
  PShape outline = newAsteroidsShape(new int[][] {{-20, 0},
    {-10, 10},
    {10, 10},
    {20, 0},
    {10, -10},
    {5, -20},
    {-5, -20},
    {-10, -10},
    {-20, 0}});
  if (red)
    outline.fill(255, 0, 0);
  PShape lowerline = createShape(LINE, -20, 0, 20, 0);
  lowerline.stroke(255);
  lowerline.noFill();
  PShape upperline = createShape(LINE, 10, -10, -10, -10);
  upperline.stroke(255);
  upperline.noFill();
  PShape a = createShape(GROUP);
  a.addChild(outline);
  a.addChild(lowerline);
  a.addChild(upperline);
  if (small) {
    a.scale(0.5);
    a.strokeWeight(2);
  }
  return a;
}

// draws the starting screen to the game
void drawHomeScreen() {
  background(0);
  // updates the asteroids on the startup screen
  for(int i = 0; i < 12; i++) {
    asteroidsHome[i].update(); 
  }
  textFont(font1);
  noStroke();
  fill(255);
  textAlign(CENTER, CENTER);
  // the game title which is centered in the screen
  text("ASTEROIDZ", (w / 2), (h / 2));
  textFont(font2);
  noStroke();
  fill(255);
  textAlign(CENTER, CENTER);
  // instructions to begin which are centered below the title
  text("Press Enter to start", (w / 2), (h / 2) + 50);
  // updates the high score in the top right corner
  updateHiScore();
}

// draws the game over screen
void drawEndScreen() {
  textFont(font3);
  fill(255, 0, 0);
  noStroke();
  textAlign(CENTER, CENTER);
  // GAME OVER drawn in red, centered in the middle of the screen
  text("GAME OVER", (w / 2), (h / 2));
  // updates the high score in the top right corner
  updateHiScore();
}

// Updates the playing world
void drawWorld() {
  if(!paused) {
    // blur background
    if (blur) {
      fill(0, alpha);
      noStroke();
      rect(0, 0, w, h);
    // black backbround
    } else
      background(0);
    // draw the selected entity
    if (selectedOne != empty)
      selectedOne.update();
    // perform all updating and drawing
    updateAsteroids();
    updateAlien();
    updateScore();
    updateHiScore();
    updateLives();
    updateBullets();
    updateShip();
    updateExplosions();
    // dim screen if game over
    if (lives < 1) {
      fill(0, 128);
      noStroke();
      rect(0, 0, w, h);
    }
  }
}

// Updates the asteroids on the screen
void updateAsteroids() {
  for (int j = 0; j < asteroids.length; j++) {
    if (asteroids[j] != selectedOne && asteroids[j].update())
      j -= 1;
  }
  // if the level is over, makes a new array that is contains one extra 
  // asteroid up to 12 large asteroids on the screen
  if (levelOver()) {
    if (leveltime >= 60) {
      if (level < 9)
        level++;
      asteroids = new Entity[level + 3];
      for (int i = 0; i < asteroids.length; i++) {
        asteroids[i] = newLargeAsteroid();
      }
      alien = empty;
      leveltime = 0;
    } else
      leveltime += 1;
  }
}

// updates the alien on the screen
void updateAlien() {
  if (alien.isEmpty) {
    // 1/120 chance near the end of a level
    // 1/2400 chance near the start of a level
    // don't spawn an alien while a new level is generating
    if (random(120 + levelStatus() * 2280) < 1 && !levelOver())
      alien = new Alien(w, random(h), floor(random(2)) + 1);
  } else {
    if (alien != selectedOne)
      alien.update();
  }
  // if the alienBullet is on the screen, update it
  if(!alienBullet.isEmpty)
    alienBullet.update();
}

// Updates the score on the top left of the screen
void updateScore() {
  String scorePars = "" + score;
  char number;
  int x = 10, y = 10;
  for(int i = 0; i < scorePars.length(); i++) {
    drawDigit(scorePars.charAt(i), x, y);
    x += 20;
  }
}

// Updates the high score on the top right of the screen
void updateHiScore() {
  // if the current score is greater than the high score then the high score
  // is set to the current score value
  if (score > hiScore) 
    hiScore = score;  
  String scorePars = "" + hiScore;
  int x = 770, y = 10;
  for(int i = scorePars.length() - 1; i >= 0; i--){
    drawDigit(scorePars.charAt(i), x, y);
    x -= 20;
  }
}

// Draws the number of lives, if the score has reached a multiple of 10,000
// an extra life is added to the game
void updateLives() {
  if (score / 10000 > extraLives) {
    lives++;
    extraLives++;
  }
  // if there are no more lives, the game is over
  if (lives == 0) {
    status = 2;
    saveHiScore();
  }
  int x = 15;
  int y = 50;
  for (int i = 0; i < lives; i++) {
    shape(life, x, y);
    x += 20;
  }
}

// Updates all of the bullets on the screen
void updateBullets() {
  for (int i = 0; i < bullets.length; i += 1) {
    if (bullets[i].update())
      i -= 1;
  }
}

// Updates the ship on the playing screen
void updateShip() {
  // quit if there are no lives
  if (lives < 1)
    return;
  if (onScreen) {
    // four frames per flame cycle
    flames = (flames + 1) % 4;
    // figure out which way the ship is turning
    float turning = 0;
    if (left) {
      turning -= turnangle;
      selectedOne = empty;
    }
    if (right) {
      turning += turnangle;
      selectedOne = empty;
    }
    if (selectedOne != empty) {
      float turnangle = -angle;
      angle = atan2(selectedOne.y - py, selectedOne.x - px);
      turnangle += angle;
      ship.rotate(turnangle);
      shipflame.rotate(turnangle);
    }
    // update the ship's angle
    // rotate ship to draw
    ship.rotate(turning);
    shipflame.rotate(turning);
    angle += turning;
    // speed it up if thrusting
    // rotate angle by 90 to get proper values relative to the ship
    if (thrust) {
      float maxv = 5 * speedunit;
      // find the goal velocity
      float endvx = maxv * cos(angle);
      float endvy = maxv * sin(angle);
      // get exponentially closer to it
      float difvx = (endvx - vx) * deceleration;
      float difvy = (endvy - vy) * deceleration;
      vx = endvx - difvx;
      vy = endvy - difvy;
    // slow it down if not thrusting
    } else {
      vx = vx * pow(deceleration, 1.0 / 2);
      vy = vy * pow(deceleration, 1.0 / 2);
    }
    // bind the ship to the screen, leaving room for it to be offscreen
    float[] bounds = boundPositions(px + vx, py + vy, 16);
    px = bounds[0];
    py = bounds[1];
    // flames every other pair of frames
    if (flames < 2 && thrust)
      shape(shipflame, px, py);
    else
      shape(ship, px, py);
  } 
  else {
    // if the ship has died, wait 1 second before respawning in the middle
    // of the screen, facing North.  Decrement the number of lives by one
    if (timeOver()) {
      //ship died, reset location and angle
      if (shipDied) {
        px = w / 2;
        py = h / 2;
        ship.rotate(-angle - PI/2);
        shipflame.rotate(-angle - PI/2);
        angle = -PI/2;
        lives--; 
        shipDied = false;
      // warp the ship to a random position
      } 
      else {
        float newX = random(800), newY = random(600);
        px = newX;
        py = newY;
      }
      vx = 0;
      vy = 0;
      onScreen = true;
    } else 
      warptime++;
  }
}

// Draw all the explosions
void updateExplosions() {
  for (int i = 0; i < explosions.length; i += 1) {
    if (explosions[i].update())
      i -= 1;
  }
}

// Draws the appropriate digit at the given x and y value
void drawDigit(char number, int x, int y) {
  if(number == '0')
    shape(zero, x, y);
  else if(number == '1')
    shape(one, x, y);
  else if(number == '2')
    shape(two, x, y);
  else if(number == '3')
    shape(three, x, y);
  else if(number == '4')
    shape(four, x, y);
  else if(number == '5')
    shape(five, x, y);
  else if(number == '6')
    shape(six, x, y);
  else if(number == '7')
    shape(seven, x, y);
  else if(number == '8')
    shape(eight, x, y);
  else if(number == '9')
    shape(nine, x, y);
}

// Checks if the time is over for warping or death
boolean timeOver() {
  // 1/2 second for warp, 3 seconds for death
  if((shipDied && warptime >= 180) || (!shipDied && warptime >= 30)) {
    warptime = 0;
    return true;
  } 
  else
    return false;
}

// Warps the ship to a randomly chosen x and y coordinate, and changes 
// the current speed to 0
void warpShip() {
  onScreen = false;
}

// If all the asteroids have been destroyed and there's no alien, 
// the level is over
boolean levelOver() {
  return asteroids.length == 0 && alien == empty;
}

// Constructs a new large asteroid
Asteroid newLargeAsteroid() {
  return newAsteroid(4);
}

// Constructs a new medium asteroid
Asteroid newMedAsteroid() {
  return newAsteroid(2);
}

// Constructs a new small asteroid
Asteroid newSmallAsteroid() {
  return newAsteroid(1);
}

// general construction of a new asteroid with a random position, random speed
// and a randomly chosen shape
Asteroid newAsteroid(int size) {
  PShape newShape;
  float astAngle = random(2 * PI);
  return new Asteroid(random(w), random(h), cos(astAngle), sin(astAngle),
      size, randomRoid(size));
}

// Chooses randomly between the 4 available asteroid shapes, scales if
// necessary
PShape randomRoid(int size) {
  if (size == 4)
    return randomRoid();
  return scaledClone(randomRoid(), size / 4.0);
}

// Chooses randomly between the 4 available asteroid shapes
PShape randomRoid() {
  //get the array position for the type
  int chooseShape = floor(random(4));
  if (chooseShape == 0)
    return roid1; 
  else if (chooseShape == 1)
    return roid2; 
  else if (chooseShape == 2)
    return roid3;
  return roid4;
}

// Scales the given shape by the given scale
PShape scaledClone(PShape s, float scale) {
  PShape clone = createShape();
  int count = s.getVertexCount();
  PVector p;
  for (int i = 0; i < count; i += 1) {
    p = s.getVertex(i);
    clone.vertex(p.x, p.y);
  }
  clone.end();
  clone.stroke(255);
  clone.noFill();
  clone.scale(scale);
  clone.strokeWeight(1 / scale);
  return clone;
}

// format x and y so that they fit on the screen
float[] boundPositions(float x, float y, float size) {
  if (x < -size)
    x += w + 2 * size;
  else if (x > w + size)
    x -= w + 2 * size;
  if (y < -size)
    y += h + 2 * size;
  else if (y > h + size)
    y -= h + 2 * size;
  return new float[] {x, y};
}

// Creates a new array that combines the two given arrays and fills it with
// the entities from both
Entity[] addToArray(Entity[] a, Entity[] b) {
  Entity[] c = new Entity[a.length + b.length];
  for (int i = 0; i < a.length; i += 1) {
    c[i] = a[i];
  }
  for (int i = 0; i < b.length; i += 1) {
    c[i + a.length] = b[i];
  }
  return c;
}

// Creates a new array that is smaller than the original by one and 
// removes the specified entity while filling in the rest of the entity
// objects
Entity[] removeFromArray(Entity[] a, Entity b) {
  Entity[] c = new Entity[a.length - 1];
  int i = 0;
  while (a[i] != b) {
    c[i] = a[i];
    i += 1;
  }
  for (i = i + 1; i < a.length; i += 1) {
    c[i - 1] = a[i];
  }
  return c;
}

// shoots a player bullet from the nose of the ship in the current direction
// the ship is pointing
void shoot() {
  if (bullets.length < 4) {
    float maxv = 5 * speedunit;
    // bullet's velocity
    float bvx = maxv * cos(angle) + vx;
    float bvy = maxv * sin(angle) + vy;
    // spawn location is the front point
    PVector frontpoint = ship.getVertex(0);
    float[] rotation = rotation(frontpoint.x, frontpoint.y, angle + PI / 2);
    bullets = addToArray(bullets, new Entity[] {new Bullet(rotation[0] + px, 
          rotation[1] + py, bvx, bvy, true)});
  }
}

// rotation function
float[] rotation(float x, float y, float angle) {
  return new float[] {x * cos(angle) - y * sin(angle), 
      x * sin(angle) + y * cos(angle)};
}

// how far you are in the level:
// 1 is no asteroids are destroyed, 0 is all asteroids are destroyed
// asteroid count = how many bullets are needed to finish all the asteroids:
// 7 for large, 3 for medium, 1 for small
float levelStatus() {
  // original total asteroid count
  float total = min(level + 3, 12) * 7;
  // current asteroid count
  int current = 0;
  Asteroid a;
  for (int i = 0; i < asteroids.length; i += 1) {
    a = (Asteroid)(asteroids[i]);
    current += a.type * 2 - 1;
  }
  return current / total;
}

// reset the game to its original state
void resetGame() {
  status = 0;
  lives = 3;
  extraLives = 0;
  score = 0;
  level = 1;
  asteroids = new Entity[] {newLargeAsteroid(),
    newLargeAsteroid(),
    newLargeAsteroid(),
    newLargeAsteroid()};
  alien = empty;
  alienBullet = empty;
  bullets = new Entity[] {};
  explosions = new Entity[] {};
  selectedOne = empty;
  warptime = 0;
  leveltime = 0;
  paused = false;
  px = w / 2;
  py = h / 2;
  vx = 0;
  vy = 0;
  angle = -PI / 2;
  left = false;
  right = false;
  thrust = false;
  onScreen = false;
  shipDied = false;
  flames = 0;
}

// save the hiscore in a file
void saveHiScore() {
  try {
    FileWriter writer = new FileWriter(new File("hiscore.txt"));
    writer.write("" + hiScore);
    writer.close();
  } catch(Exception e) {
  }
}

// general object interface
abstract class Entity {
  float x, y, vx, vy;
  boolean isEmpty = false;
  abstract boolean update();
  abstract void draw();
  abstract boolean collide();
  abstract boolean mouseWithin();
}

// replacement for null
class EmptyEntity extends Entity {
  
  EmptyEntity() {
    isEmpty = true; 
  }
  
  boolean update() {return false;}
  void draw() {}
  boolean collide() {return false;}
  boolean mouseWithin() {return false;}
}

// asteroid class
class Asteroid extends Entity {
  int type;          // what size is the asteroid?
  PShape astShape;   // the chosen shape of the asteroid
  PShape redRoid;   // a red clone of astShape
  
  Asteroid(float x, float y, float vx, float vy, int type, PShape astShape) {
    this.x = x;
    this.y = y;
    this.vx = vx;
    this.vy = vy;
    this.type = type;
    this.astShape = astShape;
    redRoid = scaledClone(astShape, type / 4.0);
    redRoid.fill(255, 0, 0);
  }
  
  // updates the location of the asteroid if it hasn't collided with something
  // return whether or not it collided
  boolean update() {
    float[] bounds = boundPositions(x + vx, y + vy, type * 10);
    x = bounds[0];
    y = bounds[1];
    if (collide()) {
      if (selectedOne == this)
        selectedOne = empty;
      return true;
    }
    draw();
    return false;
  }

  void draw() {
    if (selectedOne == this)
      shape(redRoid, x, y);
    else
      shape(astShape, x, y);
  }
  
  // Checks if the asteroid has collided with an object on the screen
  boolean collide() {
    // collide with bullets
    for (int i = 0; i < bullets.length; i += 1) {
      if (collidesWithBullet(bullets[i])) {
        Bullet b = (Bullet)(bullets[i]);
        if (type == 4)
          score += 20;
        else if (type == 2)
          score += 50;
        else
          score += 100;
        split();
        explosions = addToArray(explosions, new Entity[]{new Explosion(x, y)});
        bullets = removeFromArray(bullets, bullets[i]);
        asteroids = removeFromArray(asteroids, this);
        return true;
      }
    }
    
    // collide with alien bullet
    if(!alienBullet.isEmpty && collidesWithBullet(alienBullet)) {
      split();
      explosions = addToArray(explosions, new Entity[] {new Explosion(x, y)});
      alienBullet = empty;
      asteroids = removeFromArray(asteroids, this);
      return true; 
    }
    
    // collide with player
    if (onScreen && collidesWithPlayer()) {
      split();
      asteroids = removeFromArray(asteroids, this);
      onScreen = false;
      shipDied = true;
      explosions = addToArray(explosions, new Entity[] {new Explosion(x, y),
        new Explosion(px, py), new ShipExplosion(px, py)});
      return true;
    }
    
    // collide with alien
    if (!alien.isEmpty && collidesWithAlien()) {
      split();
      asteroids = removeFromArray(asteroids, this);
      alien = empty;
      explosions = addToArray(explosions, new Entity[] {new Explosion(x, y),
        new Explosion(alien.x, alien.y)});
      return true;
    }
    return false;
  }
  
  // check if the mosue is within this asteriod
  boolean mouseWithin() {
    return pointWithin(mouseX, mouseY);
  }
  
  // says whether or not a point is within this asteroid
  boolean pointWithin(float ax, float ay) {
    int size = type * 10;
    return ax >= x - size && ax < x + size &&
           ay >= y - size && ay < y + size;
  }
   
  // Collision check with asteroids and bullets
  boolean collidesWithBullet(Entity b) {
    return pointWithin(b.x, b.y);
  }
  
  // Collision check with asteroids and the player
  boolean collidesWithPlayer() {
    PVector shipTip = ship.getVertex(0);
    float[] rotationTip = rotation(shipTip.x, shipTip.y, angle + PI / 2);
    float[] shipTipPoint = new float[] {rotationTip[0] + px, 
        rotationTip[1] + py};
    
    PVector shipLeft = ship.getVertex(1);
    float[] rotationLeft = rotation(shipLeft.x, shipLeft.y, angle + PI / 2);
    float[] shipLeftPoint = new float[] {rotationLeft[0] + px, 
                                          rotationLeft[1] + py};
    
    PVector shipRight = ship.getVertex(ship.getVertexCount() - 2);
    float[] rotationRight = rotation(shipRight.x, shipRight.y, angle + PI / 2);
    float[] shipRightPoint = new float[] {rotationRight[0] + px,
                                             rotationRight[1] + py};
    
    return pointWithin(shipTipPoint[0], shipTipPoint[1]) ||
           pointWithin(shipLeftPoint[0], shipLeftPoint[1]) ||
           pointWithin(shipRightPoint[0], shipRightPoint[1]);
  }
  
  // Does the Asteroid collide with the Alien?
  boolean collidesWithAlien() {
    Alien a = (Alien)(alien);
    int diff = type * 10 + a.type * 10;
    return a.x >= x - diff && a.x <= x + diff &&
           a.y >= y - diff && a.y <= y + diff;
  }
  
  // splits the asteroid into two smaller asteroids
  void split() {
    if (type > 1)
      asteroids = addToArray(asteroids, new Asteroid[] {halfAsteroid(), 
                                                        halfAsteroid()});
  }
  
  // Creates a new asteroid that is half the size of the current type with
  // a random position, shape, and speed
  Asteroid halfAsteroid() {
    float angle = random(2 * PI);
    float magnitude = random(1) * speedunit;
    return new Asteroid(x, y, vx + cos(angle) * magnitude, 
            vy + sin(angle) * magnitude, type / 2, randomRoid(type / 2));
  }
  
}

// alien class
class Alien extends Entity {
  int type;  // the size of the alien
  // how long the alien must wait before it can fire another bullet
  int bulletWaitTime = 0; 
  PShape alienShape;  // the shape of the alien
  PShape redAlien;  // red copy of the shape of the alien
  
  Alien(float x, float y, int type) {
    this.x = x;
    this.y = y;
    this.vx = -1 * speedunit;
    this.vy = 0;
    this.type = type;
    this.alienShape = alienSprites[type - 1];
    this.redAlien = redAlienSprites[type - 1];
  }
  
  // Updates the alien on the screen
  boolean update() {
    if (alienBullet.isEmpty) {
      // if the bullet has been off screen for more than 30 frames, 
      // the alien can shoot again
      bulletWaitTime += 1;
      if (bulletWaitTime >= 30) {
        bulletWaitTime = 0;
        float maxv = 5 * speedunit;
        float angleToShoot;
        if (type == 1)
          angleToShoot = atan2(py - y, px - x) + random(PI / 16) - PI / 32;
        else
          angleToShoot = random(2 * PI);
        float bvx = maxv * cos(angleToShoot);
        float bvy = maxv * sin(angleToShoot);
        alienBullet = new Bullet(x, y, bvx, bvy, false);
      }
    }
    // 1/60 chance every frame to change vy
    // then pick a random vy
    if(random(60) < 1)
      vy = (floor(random(3)) - 1) * speedunit;
    float[] bounds = boundPositions(x + vx, y + vy, 20);
    x = bounds[0];
    y = bounds[1];
    if(collide()) {
      if(this == selectedOne) {
        selectedOne = empty;
        return true;
      }
    }
    draw();
    return false;
  }
  
  void draw() {
    if (this == selectedOne)
      shape(redAlien, x, y);
    else
      shape(alienShape, x, y);
  }
  
  // Checks if the asteroid has collided with an object on the screen
  boolean collide() {
    //collisions only on status 1
    if (status != 1)
      return false;
    // collide with player bullets
    for (int i = 0; i < bullets.length; i += 1) {
      if (collidesWithBullet(bullets[i])) {
        Bullet b = (Bullet)(bullets[i]);
        if (type == 1)
          score += 1000;
        else
          score += 200;
        explosions = addToArray(explosions, new Entity[]{new Explosion(x, y)});
        bullets = removeFromArray(bullets, bullets[i]);
        alien = empty;
        return true;
      }
    }
    
    // collide with player
    if (onScreen && collidesWithPlayer()) {
      alien = empty;
      onScreen = false;
      shipDied = true;
      explosions = addToArray(explosions, new Entity[] {new Explosion(x, y),
        new Explosion(px, py), new ShipExplosion(px, py)});
      return true;
    }
    // reached the left end of the screen
    if (x < -5 * type) {
      alien = empty;
      return true;
    }
    return false;
  }
  
  // Collision check with the alien and the player
  boolean collidesWithPlayer() {
    PVector shipTip = ship.getVertex(0);
    float[] rotationTip = rotation(shipTip.x, shipTip.y, angle + PI / 2);
    float[] shipTipPoint = new float[] {rotationTip[0] + px, 
        rotationTip[1] + py};
    
    PVector shipLeft = ship.getVertex(1);
    float[] rotationLeft = rotation(shipLeft.x, shipLeft.y, angle + PI / 2);
    float[] shipLeftPoint = new float[] {rotationLeft[0] + px, 
                                          rotationLeft[1] + py};
    
    PVector shipRight = ship.getVertex(ship.getVertexCount() - 2);
    float[] rotationRight = rotation(shipRight.x, shipRight.y, angle + PI / 2);
    float[] shipRightPoint = new float[] {rotationRight[0] + px,
                                             rotationRight[1] + py};
    
    return pointWithin(shipTipPoint[0], shipTipPoint[1]) ||
           pointWithin(shipLeftPoint[0], shipLeftPoint[1]) ||
           pointWithin(shipRightPoint[0], shipRightPoint[1]);
  }
  
  // check if a bullet hit this alien
  boolean collidesWithBullet(Entity b) {
    return pointWithin(b.x, b.y);
  }
  
  // check if the mosue is within this alien
  boolean mouseWithin() {
    return pointWithin(mouseX, mouseY);
  }
  
  // Is the given point within the alien?
  boolean pointWithin(float ax, float ay) {
    int size = 10 * type;
    return ax >= x - size && ax < x + size &&
           ay >= y - size && ay < y + size;
  }
}

// bullet class
class Bullet extends Entity {
  int age = 0;  // how many frames the bullet has existed
  boolean player;  // is it a player bullet?
  
  Bullet(float x, float y, float vx, float vy, boolean player) {
    this.x = x;
    this.y = y;
    this.vx = vx;
    this.vy = vy;
    this.player = player;
  }
  
  // Updates the position of the alien and ship bullets, if the ship bullet 
// has been on the screen for longer than 48 frames it disappears.
// If the alien bullet has been on the screen for longer than 30
// frames it disappears.
  boolean update() {
    age += 1;
    if (player && age > 48)
        bullets = removeFromArray(bullets, this);
    else if (!player && age > 30)
        alienBullet = empty;
    if (!player && onScreen && collide()) {
      alienBullet = empty;
      onScreen = false;
      shipDied = true;
      explosions = addToArray(explosions, new Entity[] {new Explosion(px, py),
          new ShipExplosion(px, py)});
    } else {
      float[] bounds = boundPositions(x + vx, y + vy, 0);
      x = bounds[0];
      y = bounds[1];
      draw();
    }
    return false;
  }
  
  void draw() {
    shape(bullet, x, y);
  }
  
  // collisions for bullets
  boolean collide() {
    return collideWithPlayer();
  }
  
  // Collisions with the player, only called if an alien bullet
  // Credit where credit is due: A lot of the math in this was
  // figured out thanks to  
  // http://www.blackpawn.com/texts/pointinpoly/default.html  
  boolean collideWithPlayer() {
    PVector shipTip = ship.getVertex(0);
    float[] rotationTip = rotation(shipTip.x, shipTip.y, angle + PI / 2);
    PVector shipTipPoint = new PVector (rotationTip[0] + px, 
        rotationTip[1] + py);
    
    PVector shipLeft = ship.getVertex(1);
    float[] rotationLeft = rotation(shipLeft.x, shipLeft.y, angle + PI / 2);
    PVector shipLeftPoint = new PVector (rotationLeft[0] + px, 
                                          rotationLeft[1] + py);
    
    PVector shipRight = ship.getVertex(ship.getVertexCount() - 2);
    float[] rotationRight = rotation(shipRight.x, shipRight.y, angle + PI / 2);
    PVector shipRightPoint = new PVector (rotationRight[0] + px,
                                             rotationRight[1] + py);
                                             
    PVector bulletPoint = new PVector (x, y);
    
    bulletPoint.sub(shipTipPoint);
    PVector PT = bulletPoint;
    shipRightPoint.sub(shipTipPoint);
    PVector RT = shipRightPoint;
    shipLeftPoint.sub(shipTipPoint);
    PVector LT = shipLeftPoint;
    
    float LP = PT.dot(LT);
    float RP = PT.dot(RT);
    float RL = RT.dot(LT);
    float RR = RT.dot(RT);
    float LL = LT.dot(LT);
    
    float denom = RR * LL - RL * RL;
    float alpha = (RR * LP - RL * RP) / denom;
    float beta = (LL * RP - RL * LP) / denom;
    
    return alpha >= 0 && beta >= 0 && alpha + beta < 1;
  }
  
  boolean mouseWithin() {return false;}
}

// general explosion class
class Explosion extends Entity {
  // the angle at which each explosion bit draws at 
  float[] angles = new float[10];
  int age;  // how many frames it has existed
  
  Explosion(float x, float y) {
    this.x = x;
    this.y = y;
    for (int i = 0; i < 10; i += 1) {
      angles[i] = random(2 * PI);
    }
  }
  
  // updates the dots in the explosion
  boolean update() {
    age += 1;
    if (age >= 48) {
      explosions = removeFromArray(explosions, this);
      return true;
    }
    draw();
    return false;
  }
  
  // draws the dots of the explosion
  void draw() {
    float dist = speedunit * 0.05 * age;
    for (int i = 0; i < 10; i += 1) {
      shape(explosionpoint, x + cos(angles[i]) * dist * (i + 1), 
          y + sin(angles[i]) * dist * (i + 1));
    }
  }
  
  boolean collide() {return false;}
  boolean mouseWithin() {return false;}
}

// Explosion class for the player’s ship
class ShipExplosion extends Entity {
  int age = 0;  // how many frames it has existed
  // the ship’s lines to draw
  float[][] lines = new float[5][0];
  // the velocity of each of the lines
  float[][] vels;
  
  ShipExplosion(float x, float y) {
    this.x = x;
    this.y = y;
    PVector p = ship.getVertex(0);
    float[] p1;
    float[] p2 = rotation(p.x, p.y, angle + PI / 2);
    for (int i = 0; i < 5; i += 1) {
      p1 = p2;
      p = ship.getVertex(i + 1);
      p2 = rotation(p.x, p.y, angle + PI / 2);
      lines[i] = new float[] {p1[0], p1[1], p2[0], p2[1]};
    }
    // update velocities, each one is a net of 4/60
    vels = new float[][] {rotation(-4.0 / 60, 0, angle + PI / 2),
      rotation(-2.4 / 60, 3.2 / 60, angle + PI / 2),
      rotation(0, 4.0 / 60, angle + PI / 2),
      rotation(2.4 / 60, 3.2 / 60, angle + PI / 2),
      rotation(4.0 / 60, 0, angle + PI / 2)};
  }

  boolean update() {
    age += 1;
    if (age >= 180) {
      explosions = removeFromArray(explosions, this);
      return true;
    }
    draw();
    return false;
  }

  void draw() {
    stroke(255);
    noFill();
    for (int i = age / 30; i < 5; i += 1) {
      lines[i][0] += vels[i][0];
      lines[i][1] += vels[i][1];
      lines[i][2] += vels[i][0];
      lines[i][3] += vels[i][1];
      line(lines[i][0] + x, lines[i][1] + y, lines[i][2] + x, lines[i][3] + y);
    }
  }

  boolean collide() {return false;}
  boolean mouseWithin() {return false;}
}
